
const gulp = require('gulp');
const cheerio = require('cheerio');
const path = require('path');

const prepare = require('../prepare');
const utility = require('../utility');


gulp.task('data-dev', ['annotate'], () => {
	return gulp.src('../build/meta/**/*.json')
		.pipe(utility.modifyJson((data, file) => {
			data.base = path.relative(path.dirname(file.path), file.base);
			data.index = "index.html";
			data.extname = ".html";
			data.dist = 'dev';
			//console.log("%s, %s, %s", data.base, path.dirname(file.path), file.base);

		}))
		.pipe(gulp.dest('../build/data/dev'));
});

gulp.task('data-web', ['annotate'], () => {
	return gulp.src('../build/meta/**/*.json')
		.pipe(utility.modifyJson((data, file) => {
			data.base = "/";
			data.index = "";
			data.extname = "";
			data.dist = 'web';
		}))
		.pipe(gulp.dest('../build/data/web'));
});

// generate heading indices from html
gulp.task('data', ['data-dev', 'data-web', 'reverse-tree-index'], () => {
	const index = utility.readJson('../build/reverse.json');
	return gulp.src('../build/data/**/*.json')
		.pipe(utility.modifyJson((data) => {
			const $ = cheerio.load(data.content);

			prepare.images($, data);
			prepare.links2($, data, index);

			data.content = $('body').html();
		}))
		.pipe(gulp.dest('../build/data'));
});

// Create the index files (left side nav).
gulp.task('index', ['data'], () => {
	return gulp.src('../build/data/**/_.json')
		.pipe(utility.modifyJson((data) => {
			
			const $ = cheerio.load(data.content);

			prepare.index($, data);

			data.content = $('body > ul').html();
		}))
		.pipe(gulp.dest('../build/data'));
});