
const gulp = require('gulp');
const fileTree = require('gulp-file-tree');
const cheerio = require('cheerio');
const rename = require('gulp-rename');
const path = require('path');

const utility = require('../utility');
const prepare = require('../prepare');

gulp.task('tree-index', ['annotate'], () => {
    return gulp.src('../build/meta/**/*.json')
        .pipe(fileTree())
        .pipe(gulp.dest('../build'));
});

gulp.task('reverse-tree-index', ['tree-index'], () => {
    return gulp.src('../build/tree.json')
		.pipe(utility.modifyJson((data) => {
			const reverse = {};

			const traverse = (node) => {



				if (node.isFile) {
					let key = path.basename(node.name, '.json');
					let value = node.relative.replace('.json', '');

					if (key == 'index') {

						// read the last folder name
						let dir = path.dirname(node.relative);
						key = dir.substring(dir.lastIndexOf(path.sep) + 1);
					}

					if (key != '_') {

						if (reverse[key]) {
							console.log(
								"File with duplicate key %s: %s, %s", key, reverse[key], value);
						}
						reverse[key] = value;
					}
				}

				for (child of node.children) {
					traverse(child);
				}
			}

			traverse(data);
			return utility.sortObject(reverse);
		}))
		.pipe(rename('reverse.json'))
		.pipe(gulp.dest('../build'));
});